META
{
  Parser = Game;
  Engine = G2, G2A;
  After = Gothic2SplitscreenCoop_Scripts.d;
};

// global instance of the first and second player
extern INSTANCE hero(C_NPC);
extern INSTANCE hero_2(C_NPC);

/******** 	GOTHIC 2 SPLITSCREEN COOP DAEDALUS FUNCTION INJECTIONS 			 ********/



/* GOTHIC 2 ONLY FUNCTIONS */
// Some mods remove original Gothic 2 functions, so if a mod does not feature any of these functions, 
// create a copy of this file, change the ending of it and put the functions which do not exist in the mod in comments

/************************************************************************************/
/*** 						MOBSI INJECTIONS									  ***/
/************************************************************************************/

	//Sleeping with player 2 can cause player 1 to just disappear, let's fix that here

	//func void SLEEPABIT_S1 ()
	//{
	//	var int placeholder; placeholder = Cast_InstanceToPointer(hero);
	//	if (Cast_InstanceToPointer(self) == Cast_InstanceToPointer(hero_2)){
	//		hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
	//	};
	//	SLEEPABIT_S1_old();
	//	hero = Cast_PointerToInstance(placeholder);
	//};
	
	

/************************************************************************************/
/*** 						EVENT TRIGGER INJECTIONS							  ***/
/************************************************************************************/

	func void PLAYER_HOTKEY_LAME_POTION ()
	{	
		var int placeholder; placeholder = Cast_InstanceToPointer(hero);
		if ((Cast_InstanceToPointer(self) == Cast_InstanceToPointer(hero_2)) || (Cast_InstanceToPointer(other) == Cast_InstanceToPointer(hero_2))) {
			hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
		};
		PLAYER_HOTKEY_LAME_POTION_old();
		hero = Cast_PointerToInstance(placeholder);
	};
	func void PLAYER_HOTKEY_LAME_HEAL ()
	{	
		var int placeholder; placeholder = Cast_InstanceToPointer(hero);
		if ((Cast_InstanceToPointer(self) == Cast_InstanceToPointer(hero_2)) || (Cast_InstanceToPointer(other) == Cast_InstanceToPointer(hero_2))) {
			hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
		};
		PLAYER_HOTKEY_LAME_HEAL_old();
		hero = Cast_PointerToInstance(placeholder);
	};

	func void PLAYER_HOTKEY_SCREEN_MAP ()
	{	
		var int placeholder; placeholder = Cast_InstanceToPointer(hero);
		if ((Cast_InstanceToPointer(self) == Cast_InstanceToPointer(hero_2)) || (Cast_InstanceToPointer(other) == Cast_InstanceToPointer(hero_2))) {
			hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
		};
		PLAYER_HOTKEY_SCREEN_MAP_old();
		hero = Cast_PointerToInstance(placeholder);
	};
	
	func void PLAYER_MOB_MISSING_LOCKPICK ()
	{	
		var int placeholder; placeholder = Cast_InstanceToPointer(hero);
		if ((Cast_InstanceToPointer(self) == Cast_InstanceToPointer(hero_2)) || (Cast_InstanceToPointer(other) == Cast_InstanceToPointer(hero_2))) {
			hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
		};
		PLAYER_MOB_MISSING_LOCKPICK_old();
		hero = Cast_PointerToInstance(placeholder);
	};


/************************************************************************************/
/*** 						ZS/TA INJECTIONS							 		  ***/
/************************************************************************************/


func void B_AssessPlayer ()
{
	var int placeholder; placeholder = Cast_InstanceToPointer(other);
	if ((Npc_GetDistToNpc(self, hero_2) < Npc_GetDistToNpc(self, hero))){
		other = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
	}else{
		other = Cast_PointerToInstance(Cast_InstanceToPointer(hero));
	};
	B_AssessPlayer_old();
	other = Cast_PointerToInstance(placeholder);
};

FUNC void B_AssessGuidePlayer ()
{
	var int placeholder; placeholder = Cast_InstanceToPointer(hero);
	if (Npc_GetDistToNpc(self, hero_2) < Npc_GetDistToNpc(self, hero)){
		hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
	};
	B_AssessGuidePlayer_old();
	hero = Cast_PointerToInstance(placeholder);
};

FUNC void ZS_Guide_Player ()
{
	var int placeholder; placeholder = Cast_InstanceToPointer(hero);
	if (Npc_GetDistToNpc(self, hero_2) < Npc_GetDistToNpc(self, hero)){
		hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
	};
	ZS_Guide_Player_old();
	hero = Cast_PointerToInstance(placeholder);
};

func int ZS_Guide_Player_Loop ()
{	
	var int placeholder; placeholder = Cast_InstanceToPointer(hero);
	if (Npc_GetDistToNpc(self, hero_2) < Npc_GetDistToNpc(self, hero)){
		hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
	};
	var int returnValue; returnValue = ZS_Guide_Player_Loop_old();
	hero = Cast_PointerToInstance(placeholder);
	return returnValue;
};

func int ZS_Follow_Player_Loop ()
{
	var int placeholder; placeholder = Cast_InstanceToPointer(hero);
	if (Npc_GetDistToNpc(self, hero_2) < Npc_GetDistToNpc(self, hero)){
		hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
	};
	var int returnValue; returnValue = ZS_Follow_Player_Loop_old();
	hero = Cast_PointerToInstance(placeholder);
	return returnValue;
};

func int ZS_Sleep_Loop ()
{
	var int placeholder; placeholder = Cast_InstanceToPointer(hero);
	if (Npc_GetDistToNpc(self, hero_2) < Npc_GetDistToNpc(self, hero)){
		hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
	};
	var int returnValue; returnValue = ZS_Sleep_Loop_old();
	hero = Cast_PointerToInstance(placeholder);
	return returnValue;
};

func int ZS_Sleep_Deep_Loop ()
{
	var int placeholder; placeholder = Cast_InstanceToPointer(hero);
	if (Npc_GetDistToNpc(self, hero_2) < Npc_GetDistToNpc(self, hero)){
		hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
	};
	var int returnValue; returnValue = ZS_Sleep_Deep_Loop_old();
	hero = Cast_PointerToInstance(placeholder);
	return returnValue;
};

func int ZS_Study_WP_loop ()
{
	var int placeholder; placeholder = Cast_InstanceToPointer(hero);
	if (Npc_GetDistToNpc(self, hero_2) < Npc_GetDistToNpc(self, hero)){
		hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
	};
	var int returnValue; returnValue = ZS_Study_WP_loop_old();
	hero = Cast_PointerToInstance(placeholder);
	return returnValue;
};

func int B_MM_WispDetect ()
{
	var int placeholder; placeholder = Cast_InstanceToPointer(hero);
	if (Npc_GetDistToNpc(self, hero_2) < Npc_GetDistToNpc(self, hero)){
		hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
	};
	var int returnValue; returnValue = B_MM_WispDetect_old();
	hero = Cast_PointerToInstance(placeholder);
	return returnValue;
};

func void ZS_Unconscious_End ()
{
	var int placeholder; placeholder = Cast_InstanceToPointer(hero);
	if (Npc_GetDistToNpc(self, hero_2) < Npc_GetDistToNpc(self, hero)){
		hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
	};
	ZS_Unconscious_End_old();
	hero = Cast_PointerToInstance(placeholder);
};

func int ZS_MM_Rtn_Summoned_Loop ()
{
	var int placeholder; placeholder = Cast_InstanceToPointer(hero);
	if (Npc_GetDistToNpc(self, hero_2) < Npc_GetDistToNpc(self, hero)){
		hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
	};
	var int returnValue; returnValue = ZS_MM_Rtn_Summoned_Loop_old();
	hero = Cast_PointerToInstance(placeholder);
	return returnValue;
};

func int ZS_MM_Rtn_Follow_Sheep_Loop ()
{
	var int placeholder; placeholder = Cast_InstanceToPointer(hero);
	if (Npc_GetDistToNpc(self, hero_2) < Npc_GetDistToNpc(self, hero)){
		hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
	};
	var int returnValue; returnValue = ZS_MM_Rtn_Follow_Sheep_Loop_old();
	hero = Cast_PointerToInstance(placeholder);
	return returnValue;
};

func int C_DiegoTooFar (var int tolerance)
{
	var int placeholder; placeholder = Cast_InstanceToPointer(hero);
	if (Npc_GetDistToNpc(self, hero_2) < Npc_GetDistToNpc(self, hero)){
		hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
	};
	var int returnValue; returnValue = C_DiegoTooFar_old(tolerance);
	hero = Cast_PointerToInstance(placeholder);
	return returnValue;
};

func void B_GolemRise ()
{
	var int placeholder; placeholder = Cast_InstanceToPointer(hero);
	if (Npc_GetDistToNpc(self, hero_2) < Npc_GetDistToNpc(self, hero)){
		hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
	};
	B_GolemRise_old();
	hero = Cast_PointerToInstance(placeholder);
};

func void B_Pal_ZOMBIE_RISE ()
{
	var int placeholder; placeholder = Cast_InstanceToPointer(hero);
	if (Npc_GetDistToNpc(self, hero_2) < Npc_GetDistToNpc(self, hero)){
		hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
	};
	B_Pal_ZOMBIE_RISE_old();
	hero = Cast_PointerToInstance(placeholder);
};

func void B_UseFakeScroll ()
{
	var int placeholder; placeholder = Cast_InstanceToPointer(hero);
	if (Npc_GetDistToNpc(self, hero_2) < Npc_GetDistToNpc(self, hero)){
		hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
	};
	B_UseFakeScroll_old();
	hero = Cast_PointerToInstance(placeholder);
};

func void B_SCGetTreasure_S1 ()
{
	var int placeholder; placeholder = Cast_InstanceToPointer(hero);
	if (Cast_InstanceToPointer(self) == Cast_InstanceToPointer(hero_2)){
		hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
	};
	B_SCGetTreasure_S1_old();
	hero = Cast_PointerToInstance(placeholder);
};